SystemOrganization addCategory: #'MC2-Tests-Export-Chunk'!

TestCase subclass: #MDChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Export-Chunk'!

!MDChunkTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:31'!
isAbstract
	^ self name = #MDChunkTest! !

!MDChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
write: aChunk
	| stream |
	stream := WriteStream on: String new.
	aChunk writeOn: stream.
	^ stream contents.
! !

MDChunkTest subclass: #MDClassChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Export-Chunk'!

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionA
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #normal;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionB
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusB).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #normal;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object subclass: #BogusB
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionBytes
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #bytes;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object variableByteSubclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionCategory
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Griffle';
					format: #normal;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Griffle''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionSuperclass
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #normal;
					superclassName: #String;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'String subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionVariable
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #variable;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object variableSubclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionWeak
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #weak;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object weakSubclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:41'!
testDefinitionWords
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #words;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object variableWordSubclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testRemoval
	| chunk result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	chunk remove.
	result := self write: chunk.
	self assert: result = 'Smalltalk removeClassNamed: #BogusA!!
'! !

MDChunkTest subclass: #MDClassCommentChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Export-Chunk'!

!MDClassCommentChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:43'!
testClassIsRemoved
	| chunk actual class |
	class := MDClassChunk forElement: (MDClassElement className: #BogusA).
	class remove.
	chunk := MDClassCommentChunk forElement: (MDClassCommentElement className: #BogusA).
	chunk load: MDPropertyDictionary new.
	chunk reactToClass: class.
	actual := self write: chunk.
	self assert: actual isEmpty! !

!MDClassCommentChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionWithBang
	| chunk properties actual |
	chunk := MDClassCommentChunk forElement: (MDClassCommentElement className: #BogusA).
	properties := MDPropertyDictionary new
					initials: 'cwp';
					timeStamp: (MDTimestamp fromInteger: 886029518);
					text: 'Comment!! for BogusA'
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	self assert: actual =  '!!BogusA commentStamp: ''cwp 3/28/2008 23:18'' prior: 0!!
Comment!!!! for BogusA!!
'! !

!MDClassCommentChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionWithStamp
	| chunk properties actual |
	chunk := MDClassCommentChunk forElement: (MDClassCommentElement className: #BogusA).
	properties := MDPropertyDictionary new
					initials: 'cwp';
					timeStamp: (MDTimestamp fromInteger: 886029518);
					text: 'Comment for BogusA'
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	self assert: actual =  '!!BogusA commentStamp: ''cwp 3/28/2008 23:18'' prior: 0!!
Comment for BogusA!!
'! !

!MDClassCommentChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testRemoval
	| chunk actual |
	chunk := MDClassCommentChunk forElement: (MDClassCommentElement className: #BogusA).
	chunk remove.
	actual := self write: chunk.
	self assert: actual =  '!!BogusA classComment: nil stamp: nil!!
'! !

MDChunkTest subclass: #MDMemoChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Export-Chunk'!

!MDMemoChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:44'!
testDescription
	| memo chunk actual expected  |
	memo := MDBogusRepositoryResource new setUp repository memos anyOne.
	chunk := MDMemoChunk on: memo.
	actual := self write: chunk.
	expected := '"', memo name, String cr, memo description, '"!!', String cr.
	self assert: actual = expected! !

!MDMemoChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:52'!
testDescriptionWithBang
	| memo chunk actual  |
	memo := (MDBogusRepositoryResource new setUp repository memos anyOne) copy.
	memo properties description: 'This contains a !! inside it'.
	chunk := MDMemoChunk on: memo.
	actual := self write: chunk.
	self assert: (actual includesSubString: '!!!!')! !

!MDMemoChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:52'!
testDescriptionWithDoubleQuote
	| memo chunk actual  |
	memo := (MDBogusRepositoryResource new setUp repository memos anyOne) copy.
	memo properties description: 'This contains a "quoted" phrase'.
	chunk := MDMemoChunk on: memo.
	actual := self write: chunk.
	self assert: (actual includesSubString: '""')! !

MDChunkTest subclass: #MDMethodChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Export-Chunk'!

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/19/2008 00:40'!
initializeExpected
	^ 'BogusA initialize!!

'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:57'!
methodA
	^ MDMethodChunk forElement: 
		(MDMethodElement 
			className: #BogusA 
			selector: #a
			classIsMeta: true)! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:59'!
methodAExpected
	^ '!!BogusA class methodsFor: ''capitals'' stamp: ''cwp 3/28/2008 23:18''!!
a
	^ $A!! !!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/31/2008 00:01'!
methodAExpected2
	^ '!!BogusA class methodsFor: ''capitals''!!
a
	^ $A!! !!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/31/2008 00:02'!
methodAExpected3
	^ 'BogusA class removeSelector: #a!!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/18/2008 23:51'!
methodInitialize
	^ MDMethodChunk forElement: 
		(MDMethodElement 
			className: #BogusA 
			selector: #initialize
			classIsMeta: true)! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/19/2008 00:36'!
methodInstanceInitialize
	^ MDMethodChunk forElement: 
		(MDMethodElement 
			className: #BogusA 
			selector: #initialize
			classIsMeta: false)! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/28/2008 23:37'!
methodOne
	^ MDMethodChunk forElement: 
		(MDMethodElement 
			className: #BogusA 
			selector: #one)! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:22'!
methodOneExpected
	^ '!!BogusA methodsFor: ''numbers'' stamp: ''cwp 3/28/2008 23:18''!!
one
	^ self!! !!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:22'!
methodOneExpected2
	^ '!!BogusA methodsFor: ''numbers''!!
one
	^ self!! !!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 00:59'!
methodOneExpected3
	^ 'BogusA removeSelector: #one!!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2008 20:26'!
testAInitializer
	| chunk properties stream |
	chunk := self methodA.
	properties := MDPropertyDictionary new
		category: #capitals;
		initials: 'cwp';
		timeStamp: (MDTimestamp fromInteger: 886029518);
		source: 'initialize';
		yourself.
	chunk load: properties.
	stream := WriteStream on: String new.
	chunk writeInitializerOn: stream.
	self assert: stream contents isEmpty! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2008 20:25'!
testClassDefinitionWithStamp
	| chunk properties actual expected |
	chunk := self methodA.
	properties := MDPropertyDictionary new
					category: #capitals;
					initials: 'cwp';
					timeStamp: (MDTimestamp fromInteger: 886029518);
					source: ('a', String cr, '	^ $A');
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	expected := self methodAExpected.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testClassDefinitionWithoutStamp
	| chunk properties actual expected |
	chunk := self methodA.
	properties := MDPropertyDictionary new
					category: #capitals;
					source: ('a', String cr, '	^ $A');
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	expected := self methodAExpected2.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/26/2008 20:41'!
testClassIsRemoved
	| chunk actual class |
	class := MDClassChunk forElement: (MDClassElement className: #BogusA).
	class remove.
	chunk := self methodA.
	chunk remove.
	chunk reactToClass: class.
	actual := self write: chunk.
	self assert: actual isEmpty! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testClassRemoval
	| chunk actual expected |
	chunk := self methodA.
	chunk remove.
	actual := self write: chunk.
	expected := self methodAExpected3.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2008 20:26'!
testDefinitionWithBang
	| chunk properties actual |
	chunk := self methodOne.
	properties := MDPropertyDictionary new
					category: #numbers;
					initials: 'cwp';
					timeStamp: (MDTimestamp fromInteger: 886029518);
					source: ('one', String cr, '	^ ''Sha!!bang''');
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	self assert: (actual includesSubString: '!!!!')! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2008 20:26'!
testDefinitionWithStamp
	| chunk properties actual expected |
	chunk := self methodOne.
	properties := MDPropertyDictionary new
					category: #numbers;
					initials: 'cwp';
					timeStamp: (MDTimestamp fromInteger: 886029518);
					source: ('one', String cr, '	^ self');
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	expected := self methodOneExpected.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionWithoutStamp
	| chunk properties actual expected |
	chunk := self methodOne.
	properties := MDPropertyDictionary new
					category: #numbers;
					source: ('one', String cr, '	^ self');
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	expected := self methodOneExpected2.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2008 20:26'!
testInitializer
	| chunk properties actual expected stream |
	chunk := self methodInitialize.
	properties := MDPropertyDictionary new
		category: #capitals;
		initials: 'cwp';
		timeStamp: (MDTimestamp fromInteger: 886029518);
		source: 'initialize';
		yourself.
	chunk load: properties.
	stream := WriteStream on: String new.
	chunk writeInitializerOn: stream.
	actual := stream contents.
	expected := self initializeExpected.
	self assert: actual = expected! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2008 20:26'!
testInstanceInitializer
	| chunk properties stream |
	chunk := self methodInstanceInitialize.
	properties := MDPropertyDictionary new
		category: #capitals;
		initials: 'cwp';
		timeStamp: (MDTimestamp fromInteger: 886029518);
		source: 'initialize';
		yourself.
	chunk load: properties.
	stream := WriteStream on: String new.
	chunk writeInitializerOn: stream.
	self assert: stream contents isEmpty! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/26/2008 20:03'!
testRemoval
	| chunk actual expected |
	chunk := self methodOne.
	chunk remove.
	actual := self write: chunk.
	expected := self methodOneExpected3.
	self assert: actual = expected.! !

MDChunkTest subclass: #MDVariableChunkTest
	instanceVariableNames: 'chunk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Export-Chunk'!

MDVariableChunkTest subclass: #MDClassInstVarChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Export-Chunk'!

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:30'!
expectedIndependentDefinition
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB class instVarNames includes: ''first'') ifFalse:
		[BogusB class addInstVarName: ''first'']]!!
'! !

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 20:36'!
expectedIndependentRemoval
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB class instVarNames includes: ''first'') ifTrue:
		[BogusB class removeInstVarName: ''first'']]!!
'! !

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:28'!
expectedSimpleDefinition
	^ '(BogusB class instVarNames includes: ''first'') ifFalse:
	[BogusB class addInstVarName: ''first'']!!
'! !

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 20:36'!
expectedSimpleRemoval
	^ '(BogusB class instVarNames includes: ''first'') ifTrue:
	[BogusB class removeInstVarName: ''first'']!!
'! !

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:13'!
setUp
	chunk := MDClassInstVarChunk forElement: 
				(MDClassInstVarElement className: #BogusB name: #first)! !

MDVariableChunkTest subclass: #MDClassVarChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Export-Chunk'!

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 22:23'!
expectedIndependentDefinition
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB classVarNames includes: ''First'') ifFalse:
		[BogusB addClassVarName: ''First'']]!!
'! !

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:23'!
expectedIndependentRemoval
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB classVarNames includes: ''First'') ifTrue:
		[BogusB removeClassVarName: ''First'']]!!
'! !

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 22:55'!
expectedSimpleDefinition
	^ '(BogusB classVarNames includes: ''First'') ifFalse:
	[BogusB addClassVarName: ''First'']!!
'! !

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:22'!
expectedSimpleRemoval
	^ '(BogusB classVarNames includes: ''First'') ifTrue:
	[BogusB removeClassVarName: ''First'']!!
'! !

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:13'!
setUp
	chunk := MDClassVarChunk forElement: 
				(MDClassVarElement className: #BogusB name: #First)! !

MDVariableChunkTest subclass: #MDInstVarChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Export-Chunk'!

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:40'!
expectedIndependentDefinition
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB instVarNames includes: ''first'') ifFalse:
		[BogusB addInstVarName: ''first'']]!!
'! !

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 20:38'!
expectedIndependentRemoval
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB instVarNames includes: ''first'') ifTrue:
		[BogusB removeInstVarName: ''first'']]!!
'! !

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:41'!
expectedSimpleDefinition
	^ '(BogusB instVarNames includes: ''first'') ifFalse:
	[BogusB addInstVarName: ''first'']!!
'! !

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 20:31'!
expectedSimpleRemoval
	^ '(BogusB instVarNames includes: ''first'') ifTrue:
	[BogusB removeInstVarName: ''first'']!!
'! !

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:15'!
setUp
	chunk := MDInstVarChunk forElement: (MDInstVarElement 
			className: #BogusB
			name: #first)! !

MDVariableChunkTest subclass: #MDPoolImportChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Export-Chunk'!

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:45'!
expectedIndependentDefinition
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB sharedPools includes: BogusPool) ifFalse:
		[BogusB addSharedPool: BogusPool]]!!
'! !

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:29'!
expectedIndependentRemoval
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB sharedPools includes: BogusPool) ifTrue:
		[BogusB removeSharedPool: BogusPool]]!!
'! !

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:27'!
expectedSimpleDefinition
	^ '(BogusB sharedPools includes: BogusPool) ifFalse:
	[BogusB addSharedPool: BogusPool]!!
'! !

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:29'!
expectedSimpleRemoval
	^ '(BogusB sharedPools includes: BogusPool) ifTrue:
	[BogusB removeSharedPool: BogusPool]!!
'! !

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:18'!
setUp
	chunk := MDPoolImportChunk forElement: (MDPoolImportElement 
			className: #BogusB
			name: #BogusPool)! !

!MDVariableChunkTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:30'!
isAbstract
	^ self name = #MDVariableChunkTest! !

!MDVariableChunkTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:30'!
shouldInheritSelectors
	^ true! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:38'!
testClassIsRemoved
	| actual class |
	class := MDClassChunk forElement: (MDClassElement className: #BogusB).
	class remove.
	chunk reactToClass: class.
	chunk load: MDPropertyDictionary new.
	actual := self write: chunk.
	self assert: actual isEmpty! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:20'!
testIndependentDefinition
	| actual expected |
	chunk load: MDPropertyDictionary new.
	actual := self write: chunk.
	expected := self expectedIndependentDefinition.
	self assert: actual = expected! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:20'!
testIndependentRemoval
	| actual expected |
	chunk remove.
	actual := self write: chunk.
	expected := self expectedIndependentRemoval.
	self assert: actual = expected! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:20'!
testSimpleDefinition
	| actual expected |
	chunk load: MDPropertyDictionary new.
	chunk beDependent.
	actual := self write: chunk.
	expected := self expectedSimpleDefinition.
	self assert: actual = expected! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:21'!
testSimpleRemoval
	| actual expected |
	chunk remove.
	chunk beDependent.
	actual := self write: chunk.
	expected := self expectedSimpleRemoval.
	self assert: actual = expected! !

TestCase subclass: #MDFileOutExporterTest
	instanceVariableNames: 'stream exporter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Export-Chunk'!

!MDFileOutExporterTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 23:19'!
resources
	^ {MDBogusRepositoryResource}! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/19/2008 00:26'!
bogusAInitialize
	| element variant |
	element := MDMethodElement className: #BogusA selector: #initialize classIsMeta: true.
	variant := MDDefinitionVariant forElement: element.
	variant properties
		category: #capitals;
		initials: 'cwp';
		timestamp: (MDTimestamp fromInteger: 886029518);
		source: 'initialize';
		yourself.
	^ MDElementVersion variant: variant! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/19/2008 00:57'!
classRemoval
	| element variant |
	element := MDClassElement className: #BogusB.
	variant := MDRemovalVariant forElement: element.
	^ MDElementVersion variant: variant! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 13:14'!
get: anElement
	^ self repository versions detect: [:ea | ea element = anElement]! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 23:18'!
repository
	^ MDBogusRepositoryResource current repository! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:20'!
setUp
	stream := WriteStream on: String new.
	exporter := MDFileOutExporter on: stream.! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:22'!
testClassA
	| version actual |
	version := self get: (MDClassElement className: #BogusA).
	actual := self write: version.
	self assert: (actual includesSubstring: 'BogusA' caseSensitive: true)! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:28'!
testClassAClassMethod
	| version actual |
	version := self get: (MDMethodElement
						className: #BogusA
						selector: #isCompletelyUseless
						classIsMeta: true).
	actual := self write: version.
	self assert: actual = '!!BogusA class methodsFor: ''testing'' stamp: ''cwp 4/1/2006 23:02''!!
isCompletelyUseless
	^ true!! !!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:29'!
testClassAComment
	| version actual |
	version := self get: (MDClassCommentElement className: #BogusA).
	actual := self write: version.
	self assert: actual = '!!BogusA commentStamp: ''cwp 5/30/2004 09:27'' prior: 0!!
Comment for BogusA!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:31'!
testClassBClassInstVar
	| version actual |
	version := self get: (MDClassInstVarElement 
							className: #BogusB 
							name: #firstClassInstanceVariableB).
	actual := self write: version.
	self assert: actual = '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB class instVarNames includes: ''firstClassInstanceVariableB'') ifFalse:
		[BogusB class addInstVarName: ''firstClassInstanceVariableB'']]!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:32'!
testClassBClassVar
	| version actual |
	version := self get: (MDClassVarElement className: #BogusB name: #FirstClassVariableB).
	actual := self write: version.
	self assert: actual = '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB classVarNames includes: ''FirstClassVariableB'') ifFalse:
		[BogusB addClassVarName: ''FirstClassVariableB'']]!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:33'!
testClassBInstVar
	| version actual |
	version := self get: (MDInstVarElement className: #BogusB name: #firstInstanceVariableB).
	actual := self write: version.
	self assert: actual = '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB instVarNames includes: ''firstInstanceVariableB'') ifFalse:
		[BogusB addInstVarName: ''firstInstanceVariableB'']]!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:34'!
testClassBMethod
	| version actual |
	version := self get: (MDMethodElement className: #BogusB selector: #foo).
	actual := self write: version.
	self assert: actual = '!!BogusB methodsFor: ''accessing''!!
foo
	^ self!! !!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:35'!
testClassBPoolImport
	| version actual |
	version := self get: (MDPoolImportElement className: #BogusB name: #BogusPool).
	actual := self write: version.
	self assert: actual = '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB sharedPools includes: BogusPool) ifFalse:
		[BogusB addSharedPool: BogusPool]]!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:37'!
testClassRemoval
	| actual |
	exporter addVersion: (self get: (MDClassElement className: #BogusA)).
	exporter addVersion: self classRemoval.
	exporter harmonize; flush.
	actual := stream contents.
	self assert: actual = 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!

Smalltalk removeClassNamed: #BogusB!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 22:02'!
testCompleteSnapshot
	| memo |
	memo := self repository memos anyOne.
	exporter export: memo from: self repository.
	self assert: stream contents size > 3000.! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 22:05'!
testDependenciesHonored
	| memo fileout |
	memo := self repository memos anyOne.
	exporter export: memo from: self repository.
	fileout := stream contents.
	self deny: (fileout includesSubString: 'Smalltalk hasClassNamed:')! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:46'!
testExtensionMethod
	| actual version1 version2 index1 index2 |
	version1 := self get: (MDMethodElement className: #BogusB selector: #foo).
	version2 := self get: (MDClassElement className: #BogusA).
	exporter addVersion: version1.
	exporter addVersion: version2.
	exporter harmonize.
	exporter flush.
	actual := stream contents.
	index1 := actual indexOfSubCollection: 'BogusA'.
	index2 := actual indexOfSubCollection: 'BogusB'.
	self assert: index1 < index2! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:47'!
testInitializerMethod
	| version actual |
	version := self bogusAInitialize.
	actual := self write: version.
	self assert: actual = '!!BogusA class methodsFor: ''capitals''!!
initialize!! !!

BogusA initialize!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/13/2008 16:34'!
testSharedPoolsFirst
	| memo fileout index1 index2 |
	memo := self repository memos anyOne.
	exporter export: memo from: self repository.
	fileout := stream contents.
	index1 := fileout indexOfSubCollection: 'BogusPool'.
	index2 := fileout indexOfSubCollection: 'BogusA'.
	self assert: index1 < index2! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 21:02'!
testSuperclassOrder
	| memo fileout index1 index2 |
	memo := self repository memos anyOne.
	exporter export: memo from: self repository.
	fileout := stream contents.
	index1 := fileout indexOfSubCollection: 'BogusA'.
	index2 := fileout indexOfSubCollection: 'BogusE'.
	self assert: index1 < index2! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 21:24'!
write: aVersion
	exporter addVersion: aVersion.
	exporter flush.
	^ stream contents! !

TestResource subclass: #MDBogusRepositoryResource
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Export-Chunk'!

!MDBogusRepositoryResource class methodsFor: 'as yet unclassified' stamp: 'cwp 8/23/2010 11:41'!
compileContents: aSet
	 | source |
	source := String streamContents:
		[:stream |
		stream 
			nextPutAll: 'contents';
			crtab;
			nextPutAll: '^ MDMaterializer materialize: #('.
		(SMSerializer serialize: aSet)
			do: [:b | stream print: b] separatedBy: [stream space].
		stream nextPut: $)].
	
	self compile: source ! !

!MDBogusRepositoryResource class methodsFor: 'as yet unclassified' stamp: 'cwp 8/17/2010 09:47'!
recompile
	| versions snapshot properties memo objects slice |
	slice := MDPackageInfoSlice named: 'Bogus'.
	versions := self new setUp repository versions asSet.
	snapshot := slice snapshotWithVersions: versions.
	properties := MDPropertyDictionary new
		author: 'Colin Putney <cputney@wiresong.ca>';
		comment: 'Snapshot for testing.';
		initials: 'cwp';
		ordinal: 1;
		sliceName: 'Bogus';
		yourself.
	memo := MDMemo 
		ancestry: MDAncestry new
		properties: properties
		slice: slice
		snapshot: snapshot.
	objects := versions , (Array with: snapshot with: memo).
	self compileContents: (objects asArray sort: [ :a :b | a hashstamp <= b hashstamp ])! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 10:34'!
contents
	^ SMMaterializer materialize:  #[243 4 40 252 253 249 16 77 68 69 108 101 109 101 110 116 86 101 114 115 105 111 110 1 3 251 9 104 97 115 104 115 116 97 109 112 251 7 118 97 114 105 97 110 116 251 8 97 110 99 101 115 116 114 121 3 251 9 104 97 115 104 115 116 97 109 112 251 7 118 97 114 105 97 110 116 251 8 97 110 99 101 115 116 114 121 252 253 249 11 77 68 72 97 115 104 115 116 97 109 112 3 0 24 52 210 77 14 52 231 205 170 249 9 150 132 226 101 8 89 190 3 184 54 173 221 73 95 252 253 249 19 77 68 68 101 102 105 110 105 116 105 111 110 86 97 114 105 97 110 116 1 2 251 7 101 108 101 109 101 110 116 251 10 112 114 111 112 101 114 116 105 101 115 2 251 7 101 108 101 109 101 110 116 251 10 112 114 111 112 101 114 116 105 101 115 252 253 249 14 77 68 67 108 97 115 115 69 108 101 109 101 110 116 1 1 251 12 116 104 101 67 108 97 115 115 78 97 109 101 1 251 12 116 104 101 67 108 97 115 115 78 97 109 101 249 6 66 111 103 117 115 65 252 253 249 20 77 68 80 114 111 112 101 114 116 121 68 105 99 116 105 111 110 97 114 121 1 3 251 5 116 97 108 108 121 251 5 97 114 114 97 121 251 14 108 111 99 97 108 82 101 102 101 114 101 110 99 101 3 251 5 116 97 108 108 121 251 5 97 114 114 97 121 251 14 108 111 99 97 108 82 101 102 101 114 101 110 99 101 3 243 4 5 243 1 243 1 252 253 249 11 65 115 115 111 99 105 97 116 105 111 110 1 2 251 3 107 101 121 251 5 118 97 108 117 101 2 251 3 107 101 121 251 5 118 97 108 117 101 249 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 249 6 79 98 106 101 99 116 252 255 14 249 8 99 97 116 101 103 111 114 121 249 10 66 111 103 117 115 45 66 97 115 101 252 255 14 249 6 102 111 114 109 97 116 249 6 110 111 114 109 97 108 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 61 45 189 178 223 168 83 176 193 250 37 95 154 78 44 42 38 199 60 221 252 255 7 252 253 249 15 77 68 77 101 116 104 111 100 69 108 101 109 101 110 116 1 3 251 12 116 104 101 67 108 97 115 115 78 97 109 101 251 8 115 101 108 101 99 116 111 114 251 11 99 108 97 115 115 73 115 77 101 116 97 3 251 12 116 104 101 67 108 97 115 115 78 97 109 101 251 8 115 101 108 101 99 116 111 114 251 11 99 108 97 115 115 73 115 77 101 116 97 249 6 66 111 103 117 115 66 249 22 115 101 110 100 115 83 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 46 115 101 110 100 115 83 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 13 9 115 101 108 102 32 115 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 7 115 101 110 100 101 114 115 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 178 81 54 218 189 119 201 106 75 113 238 141 169 50 185 129 13 149 226 25 252 255 7 252 253 249 16 77 68 73 110 115 116 86 97 114 69 108 101 109 101 110 116 1 2 251 12 116 104 101 67 108 97 115 115 78 97 109 101 251 4 110 97 109 101 2 251 12 116 104 101 67 108 97 115 115 78 97 109 101 251 4 110 97 109 101 249 6 66 111 103 117 115 66 251 23 115 101 99 111 110 100 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 252 255 11 0 243 4 5 243 1 243 1 243 1 243 1 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 103 181 246 76 222 120 245 4 240 231 10 78 122 7 176 194 141 103 99 210 252 255 7 252 255 22 249 6 66 111 103 117 115 65 249 3 111 110 101 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 8 111 110 101 13 9 94 32 49 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 7 110 117 109 98 101 114 115 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 37 101 63 31 21 93 91 181 27 36 1 22 247 129 50 251 113 246 113 109 252 255 7 252 255 22 249 6 66 111 103 117 115 67 249 12 104 97 115 84 105 109 101 115 116 97 109 112 243 3 252 255 11 4 243 4 11 252 255 14 249 9 116 105 109 101 83 116 97 109 112 252 253 249 11 77 68 84 105 109 101 115 116 97 109 112 3 0 4 45 159 254 52 252 255 14 249 8 99 97 116 101 103 111 114 121 249 7 116 101 115 116 105 110 103 243 1 243 1 243 1 252 255 14 249 8 105 110 105 116 105 97 108 115 251 3 99 119 112 243 1 243 1 243 1 243 1 252 255 14 249 6 115 111 117 114 99 101 251 20 104 97 115 84 105 109 101 115 116 97 109 112 13 9 94 32 116 114 117 101 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 97 131 57 131 223 77 24 55 160 77 37 167 231 158 13 192 136 242 235 119 252 255 7 252 255 22 249 6 66 111 103 117 115 66 249 12 97 99 99 101 115 115 101 115 73 118 97 114 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 38 97 99 99 101 115 115 101 115 73 118 97 114 13 9 94 32 102 105 114 115 116 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 9 97 99 99 101 115 115 105 110 103 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 0 96 22 96 186 91 34 6 210 251 173 9 35 1 19 142 16 235 91 185 252 255 7 252 255 32 249 6 66 111 103 117 115 66 251 22 102 105 114 115 116 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 252 255 11 0 243 4 5 243 1 243 1 243 1 243 1 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 127 102 112 135 183 139 81 238 28 8 124 5 41 100 83 15 121 166 79 159 252 255 7 252 255 22 249 6 66 111 103 117 115 65 249 1 97 243 2 252 255 11 4 243 4 11 252 255 14 249 9 116 105 109 101 83 116 97 109 112 252 255 53 4 49 17 69 60 252 255 14 249 8 99 97 116 101 103 111 114 121 249 8 99 97 112 105 116 97 108 115 243 1 243 1 243 1 252 255 14 249 8 105 110 105 116 105 97 108 115 251 3 99 119 112 243 1 243 1 243 1 243 1 252 255 14 249 6 115 111 117 114 99 101 251 7 97 13 9 94 32 36 66 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 244 222 112 92 102 167 130 99 8 181 45 21 239 216 90 161 235 54 32 150 252 255 7 252 255 9 249 6 66 111 103 117 115 69 252 255 11 3 243 4 5 243 1 243 1 252 255 14 249 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 249 6 66 111 103 117 115 65 252 255 14 249 8 99 97 116 101 103 111 114 121 249 10 66 111 103 117 115 45 66 97 115 101 252 255 14 249 6 102 111 114 109 97 116 249 6 110 111 114 109 97 108 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 114 39 31 132 67 227 32 151 94 159 185 49 10 186 151 214 128 18 156 190 252 255 7 252 255 9 249 6 66 111 103 117 115 67 252 255 11 3 243 4 5 243 1 243 1 252 255 14 249 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 249 6 79 98 106 101 99 116 252 255 14 249 8 99 97 116 101 103 111 114 121 249 10 66 111 103 117 115 45 66 97 115 101 252 255 14 249 6 102 111 114 109 97 116 249 6 110 111 114 109 97 108 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 235 132 41 59 29 172 151 93 65 63 89 87 11 139 131 93 203 27 70 190 252 255 7 252 255 22 249 6 66 111 103 117 115 66 249 16 97 99 99 101 115 115 101 115 67 86 97 114 65 108 115 111 243 2 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 39 97 99 99 101 115 115 101 115 67 86 97 114 65 108 115 111 13 9 94 32 70 105 114 115 116 67 108 97 115 115 86 97 114 105 97 98 108 101 66 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 9 97 99 99 101 115 115 105 110 103 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 192 75 13 44 171 2 83 203 214 251 38 81 214 25 25 178 151 220 117 31 252 255 7 252 255 22 249 6 66 111 103 117 115 65 249 1 98 243 2 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 7 98 13 9 94 32 36 66 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 8 99 97 112 105 116 97 108 115 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 124 211 224 13 102 27 175 154 33 126 153 141 123 134 252 171 129 212 111 47 252 255 7 252 253 249 21 77 68 67 108 97 115 115 73 110 115 116 86 97 114 69 108 101 109 101 110 116 1 2 251 12 116 104 101 67 108 97 115 115 78 97 109 101 251 4 110 97 109 101 2 251 12 116 104 101 67 108 97 115 115 78 97 109 101 251 4 110 97 109 101 249 6 66 111 103 117 115 66 251 28 115 101 99 111 110 100 67 108 97 115 115 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 252 255 11 0 243 4 5 243 1 243 1 243 1 243 1 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 12 161 138 118 66 53 74 7 205 44 17 60 168 209 207 137 42 8 101 114 252 255 7 252 255 9 249 6 66 111 103 117 115 74 252 255 11 3 243 4 5 243 1 243 1 252 255 14 249 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 249 6 79 98 106 101 99 116 252 255 14 249 8 99 97 116 101 103 111 114 121 249 13 66 111 103 117 115 45 70 111 114 109 97 116 115 252 255 14 249 6 102 111 114 109 97 116 249 4 119 101 97 107 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 84 197 83 60 201 6 30 247 56 50 3 223 18 54 188 15 235 162 82 21 252 255 7 252 255 22 249 6 66 111 103 117 115 65 249 19 105 115 67 111 109 112 108 101 116 101 108 121 85 115 101 108 101 115 115 243 2 252 255 11 4 243 4 11 252 255 14 249 9 116 105 109 101 83 116 97 109 112 252 255 53 4 49 17 70 104 252 255 14 249 8 99 97 116 101 103 111 114 121 249 7 116 101 115 116 105 110 103 243 1 243 1 243 1 252 255 14 249 8 105 110 105 116 105 97 108 115 251 3 99 119 112 243 1 243 1 243 1 243 1 252 255 14 249 6 115 111 117 114 99 101 251 27 105 115 67 111 109 112 108 101 116 101 108 121 85 115 101 108 101 115 115 13 9 94 32 116 114 117 101 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 174 199 45 103 130 222 113 206 114 7 199 136 85 139 27 160 138 60 53 104 252 255 7 252 255 22 249 6 66 111 103 117 115 65 249 28 98 111 103 117 115 72 111 112 101 102 117 108 108 121 85 110 105 113 117 101 83 101 108 101 99 116 111 114 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 59 98 111 103 117 115 72 111 112 101 102 117 108 108 121 85 110 105 113 117 101 83 101 108 101 99 116 111 114 13 9 115 101 108 102 32 98 111 103 117 115 79 116 104 101 114 85 110 105 113 117 101 83 101 108 101 99 116 111 114 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 5 111 116 104 101 114 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 85 7 149 75 76 191 83 164 68 197 12 238 62 108 118 102 53 51 25 146 252 255 7 252 255 22 249 6 66 111 103 117 115 65 249 4 102 105 118 101 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 29 102 105 118 101 13 9 94 32 115 101 108 102 32 116 119 111 32 43 32 115 101 108 102 32 116 104 114 101 101 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 7 110 117 109 98 101 114 115 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 234 101 88 215 90 39 34 19 190 35 248 135 77 47 119 172 132 129 130 45 252 255 7 252 255 9 249 6 66 111 103 117 115 71 252 255 11 3 243 4 5 243 1 243 1 252 255 14 249 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 249 6 79 98 106 101 99 116 252 255 14 249 8 99 97 116 101 103 111 114 121 249 13 66 111 103 117 115 45 70 111 114 109 97 116 115 252 255 14 249 6 102 111 114 109 97 116 249 5 98 121 116 101 115 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 180 202 40 165 94 45 91 44 94 95 13 150 101 0 68 221 87 17 206 66 252 255 7 252 255 22 249 6 66 111 103 117 115 66 249 3 102 111 111 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 11 102 111 111 13 9 94 32 115 101 108 102 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 9 97 99 99 101 115 115 105 110 103 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 194 200 69 48 219 8 193 197 224 64 242 33 226 124 130 171 157 235 240 156 252 255 7 252 255 22 249 6 66 111 103 117 115 65 249 8 105 115 83 116 114 105 110 103 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 17 105 115 83 116 114 105 110 103 13 9 94 32 102 97 108 115 101 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 5 111 116 104 101 114 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 100 251 36 27 189 182 116 22 214 53 106 67 117 15 54 73 188 59 162 171 252 255 7 252 253 249 17 77 68 67 108 97 115 115 86 97 114 69 108 101 109 101 110 116 1 2 251 12 116 104 101 67 108 97 115 115 78 97 109 101 251 4 110 97 109 101 2 251 12 116 104 101 67 108 97 115 115 78 97 109 101 251 4 110 97 109 101 249 6 66 111 103 117 115 66 249 19 70 105 114 115 116 67 108 97 115 115 86 97 114 105 97 98 108 101 66 252 255 11 0 243 4 5 243 1 243 1 243 1 243 1 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 202 123 201 142 179 22 126 136 162 188 187 169 250 199 124 21 159 214 180 84 252 255 7 252 253 249 19 77 68 80 111 111 108 73 109 112 111 114 116 69 108 101 109 101 110 116 1 2 251 12 116 104 101 67 108 97 115 115 78 97 109 101 251 4 110 97 109 101 2 251 12 116 104 101 67 108 97 115 115 78 97 109 101 251 4 110 97 109 101 249 6 66 111 103 117 115 66 249 9 66 111 103 117 115 80 111 111 108 252 255 11 0 243 4 5 243 1 243 1 243 1 243 1 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 83 103 37 53 8 92 100 220 243 206 109 93 253 239 107 49 164 1 65 36 252 255 7 252 255 9 249 6 66 111 103 117 115 70 252 255 11 3 243 4 5 243 1 243 1 252 255 14 249 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 249 6 79 98 106 101 99 116 252 255 14 249 8 99 97 116 101 103 111 114 121 249 13 66 111 103 117 115 45 70 111 114 109 97 116 115 252 255 14 249 6 102 111 114 109 97 116 249 6 110 111 114 109 97 108 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 73 242 198 17 93 106 121 199 75 191 141 96 100 79 142 158 152 155 94 175 252 255 7 252 255 22 249 6 66 111 103 117 115 65 249 5 116 104 114 101 101 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 10 116 104 114 101 101 13 9 94 32 51 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 7 110 117 109 98 101 114 115 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 190 38 67 92 97 67 244 24 254 111 238 52 234 82 134 218 87 232 239 221 252 255 7 252 255 204 249 6 66 111 103 117 115 66 249 20 83 101 99 111 110 100 67 108 97 115 115 86 97 114 105 97 98 108 101 66 252 255 11 0 243 4 5 243 1 243 1 243 1 243 1 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 130 165 202 235 187 78 91 26 22 229 26 79 10 18 191 173 137 238 65 178 252 255 7 252 253 249 21 77 68 67 108 97 115 115 67 111 109 109 101 110 116 69 108 101 109 101 110 116 1 1 251 12 116 104 101 67 108 97 115 115 78 97 109 101 1 251 12 116 104 101 67 108 97 115 115 78 97 109 101 249 6 66 111 103 117 115 65 252 255 11 3 243 4 5 243 1 252 255 14 249 8 105 110 105 116 105 97 108 115 251 3 99 119 112 252 255 14 249 9 116 105 109 101 83 116 97 109 112 252 255 53 4 45 155 232 228 252 255 14 249 4 116 101 120 116 251 18 67 111 109 109 101 110 116 32 102 111 114 32 66 111 103 117 115 65 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 237 166 92 141 201 208 41 114 181 163 176 96 229 8 73 205 123 107 80 195 252 255 7 252 255 22 249 6 66 111 103 117 115 65 249 3 116 119 111 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 8 116 119 111 13 9 94 32 50 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 7 110 117 109 98 101 114 115 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 185 121 79 71 245 202 96 155 100 117 149 152 63 54 121 166 210 126 240 4 252 255 7 252 255 22 249 6 66 111 103 117 115 65 249 1 98 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 7 98 13 9 94 32 36 66 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 7 108 101 116 116 101 114 115 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 182 111 208 115 69 214 134 126 221 103 177 88 113 230 157 219 240 28 145 70 252 255 7 252 255 22 249 6 66 111 103 117 115 65 249 24 98 111 103 117 115 79 116 104 101 114 85 110 105 113 117 101 83 101 108 101 99 116 111 114 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 32 98 111 103 117 115 79 116 104 101 114 85 110 105 113 117 101 83 101 108 101 99 116 111 114 13 9 94 32 115 101 108 102 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 5 111 116 104 101 114 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 13 153 252 85 5 231 220 195 191 39 76 181 177 216 17 97 222 141 233 177 252 255 7 252 255 9 249 9 66 111 103 117 115 80 111 111 108 252 255 11 3 243 4 5 243 1 243 1 252 255 14 249 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 249 10 83 104 97 114 101 100 80 111 111 108 252 255 14 249 8 99 97 116 101 103 111 114 121 249 11 66 111 103 117 115 45 80 111 111 108 115 252 255 14 249 6 102 111 114 109 97 116 249 6 110 111 114 109 97 108 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 56 135 171 204 143 51 44 23 172 188 180 175 38 16 193 109 238 7 147 158 252 255 7 252 255 22 249 6 66 111 103 117 115 66 249 12 97 99 99 101 115 115 101 115 67 86 97 114 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 35 97 99 99 101 115 115 101 115 67 86 97 114 13 9 94 32 70 105 114 115 116 67 108 97 115 115 86 97 114 105 97 98 108 101 66 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 9 97 99 99 101 115 115 105 110 103 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 14 60 23 94 19 238 118 253 208 68 157 14 25 195 215 183 252 177 80 162 252 255 7 252 255 22 249 6 66 111 103 117 115 65 249 1 97 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 7 97 13 9 94 32 36 65 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 7 108 101 116 116 101 114 115 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 120 220 20 10 115 48 47 190 159 207 79 4 177 43 72 157 68 225 184 32 252 255 7 252 255 9 249 6 66 111 103 117 115 72 252 255 11 3 243 4 5 243 1 243 1 252 255 14 249 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 249 6 79 98 106 101 99 116 252 255 14 249 8 99 97 116 101 103 111 114 121 249 13 66 111 103 117 115 45 70 111 114 109 97 116 115 252 255 14 249 6 102 111 114 109 97 116 249 8 118 97 114 105 97 98 108 101 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 214 21 181 95 91 185 196 101 226 208 37 56 214 23 240 64 247 129 10 79 252 255 7 252 255 9 249 6 66 111 103 117 115 66 252 255 11 3 243 4 5 243 1 243 1 252 255 14 249 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 249 6 79 98 106 101 99 116 252 255 14 249 8 99 97 116 101 103 111 114 121 249 10 66 111 103 117 115 45 66 97 115 101 252 255 14 249 6 102 111 114 109 97 116 249 6 110 111 114 109 97 108 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 231 84 147 29 195 242 183 254 48 149 125 134 32 249 170 86 74 117 154 81 252 255 7 252 255 9 249 6 66 111 103 117 115 73 252 255 11 3 243 4 5 243 1 243 1 252 255 14 249 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 249 6 79 98 106 101 99 116 252 255 14 249 8 99 97 116 101 103 111 114 121 249 13 66 111 103 117 115 45 70 111 114 109 97 116 115 252 255 14 249 6 102 111 114 109 97 116 249 5 119 111 114 100 115 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 172 113 166 5 104 236 190 161 157 134 239 109 236 157 22 168 31 73 194 145 252 255 7 252 255 22 249 6 66 111 103 117 115 65 249 19 98 111 103 117 115 85 110 115 101 110 116 83 101 108 101 99 116 111 114 243 3 252 255 11 4 243 4 11 252 255 14 249 9 116 105 109 101 83 116 97 109 112 252 255 53 4 50 96 25 84 252 255 14 249 8 99 97 116 101 103 111 114 121 249 5 111 116 104 101 114 243 1 243 1 243 1 252 255 14 249 8 105 110 105 116 105 97 108 115 251 3 99 119 112 243 1 243 1 243 1 243 1 252 255 14 249 6 115 111 117 114 99 101 251 27 98 111 103 117 115 85 110 115 101 110 116 83 101 108 101 99 116 111 114 13 9 94 32 115 101 108 102 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 62 175 205 208 183 226 168 140 69 151 12 91 60 28 92 18 175 234 226 58 252 255 7 252 255 22 249 6 66 111 103 117 115 66 249 17 115 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 243 3 252 255 11 2 243 4 5 252 255 14 249 6 115 111 117 114 99 101 251 36 115 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 13 9 115 101 108 102 32 97 99 99 101 115 115 101 115 73 118 97 114 243 1 243 1 252 255 14 249 8 99 97 116 101 103 111 114 121 249 7 115 101 110 100 101 114 115 243 1 243 1 243 11 0 252 255 3 252 255 5 24 52 210 77 15 109 25 42 228 7 248 182 246 80 80 214 183 197 80 31 252 163 148 21 41 252 255 7 252 255 128 249 6 66 111 103 117 115 66 251 27 102 105 114 115 116 67 108 97 115 115 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 252 255 11 0 243 4 5 243 1 243 1 243 1 243 1 243 1 243 1 243 11 0 252 253 249 10 77 68 83 110 97 112 115 104 111 116 1 3 251 9 104 97 115 104 115 116 97 109 112 251 6 101 110 117 109 73 100 251 8 99 111 110 116 101 110 116 115 3 251 9 104 97 115 104 115 116 97 109 112 251 6 101 110 117 109 73 100 251 8 99 111 110 116 101 110 116 115 252 255 5 24 53 3 166 54 229 37 37 226 2 209 243 112 199 17 131 84 93 67 14 95 228 70 233 84 252 255 5 24 57 76 150 77 144 78 94 179 158 4 238 250 124 209 17 166 73 142 144 50 93 164 235 137 243 11 38 252 255 5 24 52 210 77 15 124 211 224 13 102 27 175 154 33 126 153 141 123 134 252 171 129 212 111 47 252 255 5 24 52 210 77 15 127 102 112 135 183 139 81 238 28 8 124 5 41 100 83 15 121 166 79 159 252 255 5 24 52 210 77 15 37 101 63 31 21 93 91 181 27 36 1 22 247 129 50 251 113 246 113 109 252 255 5 24 52 210 77 15 56 135 171 204 143 51 44 23 172 188 180 175 38 16 193 109 238 7 147 158 252 255 5 24 52 210 77 15 237 166 92 141 201 208 41 114 181 163 176 96 229 8 73 205 123 107 80 195 252 255 5 24 52 210 77 15 180 202 40 165 94 45 91 44 94 95 13 150 101 0 68 221 87 17 206 66 252 255 5 24 52 210 77 15 174 199 45 103 130 222 113 206 114 7 199 136 85 139 27 160 138 60 53 104 252 255 5 24 52 210 77 15 13 153 252 85 5 231 220 195 191 39 76 181 177 216 17 97 222 141 233 177 252 255 5 24 52 210 77 15 172 113 166 5 104 236 190 161 157 134 239 109 236 157 22 168 31 73 194 145 252 255 5 24 52 210 77 15 100 251 36 27 189 182 116 22 214 53 106 67 117 15 54 73 188 59 162 171 252 255 5 24 52 210 77 15 12 161 138 118 66 53 74 7 205 44 17 60 168 209 207 137 42 8 101 114 252 255 5 24 52 210 77 15 62 175 205 208 183 226 168 140 69 151 12 91 60 28 92 18 175 234 226 58 252 255 5 24 52 210 77 15 14 60 23 94 19 238 118 253 208 68 157 14 25 195 215 183 252 177 80 162 252 255 5 24 52 210 77 15 182 111 208 115 69 214 134 126 221 103 177 88 113 230 157 219 240 28 145 70 252 255 5 24 52 210 77 15 178 81 54 218 189 119 201 106 75 113 238 141 169 50 185 129 13 149 226 25 252 255 5 24 52 210 77 15 194 200 69 48 219 8 193 197 224 64 242 33 226 124 130 171 157 235 240 156 252 255 5 24 52 210 77 15 73 242 198 17 93 106 121 199 75 191 141 96 100 79 142 158 152 155 94 175 252 255 5 24 52 210 77 15 114 39 31 132 67 227 32 151 94 159 185 49 10 186 151 214 128 18 156 190 252 255 5 24 52 210 77 15 120 220 20 10 115 48 47 190 159 207 79 4 177 43 72 157 68 225 184 32 252 255 5 24 52 210 77 15 190 38 67 92 97 67 244 24 254 111 238 52 234 82 134 218 87 232 239 221 252 255 5 24 52 210 77 15 185 121 79 71 245 202 96 155 100 117 149 152 63 54 121 166 210 126 240 4 252 255 5 24 52 210 77 15 192 75 13 44 171 2 83 203 214 251 38 81 214 25 25 178 151 220 117 31 252 255 5 24 52 210 77 14 52 231 205 170 249 9 150 132 226 101 8 89 190 3 184 54 173 221 73 95 252 255 5 24 52 210 77 15 97 131 57 131 223 77 24 55 160 77 37 167 231 158 13 192 136 242 235 119 252 255 5 24 52 210 77 15 0 96 22 96 186 91 34 6 210 251 173 9 35 1 19 142 16 235 91 185 252 255 5 24 52 210 77 15 84 197 83 60 201 6 30 247 56 50 3 223 18 54 188 15 235 162 82 21 252 255 5 24 52 210 77 15 235 132 41 59 29 172 151 93 65 63 89 87 11 139 131 93 203 27 70 190 252 255 5 24 52 210 77 15 202 123 201 142 179 22 126 136 162 188 187 169 250 199 124 21 159 214 180 84 252 255 5 24 52 210 77 15 83 103 37 53 8 92 100 220 243 206 109 93 253 239 107 49 164 1 65 36 252 255 5 24 52 210 77 15 214 21 181 95 91 185 196 101 226 208 37 56 214 23 240 64 247 129 10 79 252 255 5 24 52 210 77 15 103 181 246 76 222 120 245 4 240 231 10 78 122 7 176 194 141 103 99 210 252 255 5 24 52 210 77 15 130 165 202 235 187 78 91 26 22 229 26 79 10 18 191 173 137 238 65 178 252 255 5 24 52 210 77 15 231 84 147 29 195 242 183 254 48 149 125 134 32 249 170 86 74 117 154 81 252 255 5 24 52 210 77 15 109 25 42 228 7 248 182 246 80 80 214 183 197 80 31 252 163 148 21 41 252 255 5 24 52 210 77 15 61 45 189 178 223 168 83 176 193 250 37 95 154 78 44 42 38 199 60 221 252 255 5 24 52 210 77 15 244 222 112 92 102 167 130 99 8 181 45 21 239 216 90 161 235 54 32 150 252 255 5 24 52 210 77 15 234 101 88 215 90 39 34 19 190 35 248 135 77 47 119 172 132 129 130 45 252 255 5 24 52 210 77 15 85 7 149 75 76 191 83 164 68 197 12 238 62 108 118 102 53 51 25 146 252 253 249 6 77 68 77 101 109 111 1 5 251 9 104 97 115 104 115 116 97 109 112 251 9 114 101 102 101 114 101 110 99 101 251 8 97 110 99 101 115 116 114 121 251 10 112 114 111 112 101 114 116 105 101 115 251 7 115 108 105 99 101 73 100 5 251 9 104 97 115 104 115 116 97 109 112 251 9 114 101 102 101 114 101 110 99 101 251 8 97 110 99 101 115 116 114 121 251 10 112 114 111 112 101 114 116 105 101 115 251 7 115 108 105 99 101 73 100 252 255 5 24 53 3 166 54 130 165 231 52 111 158 2 155 193 176 132 194 121 175 137 159 49 93 76 108 252 255 5 24 53 3 166 54 229 37 37 226 2 209 243 112 199 17 131 84 93 67 14 95 228 70 233 84 243 4 0 252 255 11 5 243 4 11 243 1 252 255 14 249 7 99 111 109 109 101 110 116 251 21 83 110 97 112 115 104 111 116 32 102 111 114 32 116 101 115 116 105 110 103 46 243 1 252 255 14 249 7 111 114 100 105 110 97 108 1 243 1 252 255 14 249 8 105 110 105 116 105 97 108 115 251 3 99 119 112 243 1 252 255 14 249 9 115 108 105 99 101 78 97 109 101 251 5 66 111 103 117 115 243 1 243 1 252 255 14 249 6 97 117 116 104 111 114 251 34 67 111 108 105 110 32 80 117 116 110 101 121 32 60 99 112 117 116 110 101 121 64 119 105 114 101 115 111 110 103 46 99 97 62 243 1 252 255 5 24 57 76 150 77 144 78 94 179 158 4 238 250 124 209 17 166 73 142 144 50 93 164 235 137]! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 4/7/2008 23:34'!
fileout
	| out exporter memo |
	out := WriteStream on: String new.
	exporter := MDFileOutExporter on: out.
	memo := repository memos anyOne.
	exporter export: memo from: repository.
	^ out contents

! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 3/23/2008 23:48'!
repository
	^ repository! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 10/19/2009 02:20'!
setUp
	
	repository := MDMemoryRepository forTesting.
	repository putAll: self contents! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
tearDown
	repository := nil! !
